/* This file is designed for the LCD display.*/
/*It is designed by Lijingjiao*/
/*Control: SED1520  LCD NAME:     MGLS100*32*/
#include "gp32.h"
/*ж*/
#define cli() _asm("cli\n")
/*ж*/
#define sei() _asm("sei\n")
#define nop() _asm("nop\n")
typedef struct bits {
	unsigned char b0:1;
	unsigned char b1:1;
	unsigned char b2:1;
	unsigned char b3:1;
	unsigned char b4:1;
	unsigned char b5:1;
	unsigned char b6:1;
	unsigned char b7:1;
	}BITS;

typedef union bit_char {
	unsigned char byte;
	BITS b;
	} BIT_CHAR;

#define BSET(x, y)  ((x).b.b ## y = 1)
#define BCLR(x, y)  ((x).b.b ## y = 0)
#define CLRBYTE(x)  ((x).byte = 0)
@tiny volatile BIT_CHAR PTC @0x02;

unsigned char CLMADD,PAGEADD,Row,command,data;
int i,k,l,m;	
unsigned char PAGENUM,CLMSUM;

const unsigned char KeyValue[4]={0xfe,0xfd,0xfb,0xf7};
const unsigned char KeyTable[16]={0xee,0xde,0xbe,0x7e,
  				0xed,0xdd,0xbd,0x7d,
  				0xeb,0xdb,0xbb,0x7b,
  				0xe7,0xd7,0xb7,0x77};
  								  
const char CTable[128]={            //16ַ
0x00,0x26,0x49,0x49,0x49,0x32,0x00,0x00,// S
0x00,0x7F,0x49,0x49,0x49,0x49,0x00,0x00,// E
0x00,0x41,0x7F,0x41,0x41,0x3E,0x00,0x00, //D
0x00,0x00,0x42,0x7F,0x40,0x00,0x00,0x00,// 1
0x00,0x27,0x45,0x45,0x45,0x39,0x00,0x00,// 5
0x00,0x42,0x61,0x51,0x49,0x46,0x00,0x00,//2
0x00,0x3e,0x51,0x49,0x45,0x3e,0x00,0x00,//0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //
0x00,0x7F,0x40,0x40,0x40,0x40,0x00,0x00, //L
0x00,0x3E,0x41,0x41,0x41,0x22,0x00,0x00, //C
0x00,0x41,0x7F,0x41,0x41,0x3E,0x00,0x00, //D
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //
0x00,0x3E,0x41,0x41,0x49,0x7A,0x00,0x00, //G
0x00,0x7F,0x09,0x09,0x09,0x06,0x00,0x00, //P
0x00,0x21,0x41,0x45,0x4B,0x31,0x00,0x00, //3
0x00,0x42,0x61,0x51,0x49,0x46,0x00,0x00,//2
};

const char table[128]={
0x10,0x61,0x06,0xE0,0x18,0x84,0xE4,0x1C,0x84,0x65,0xBE,0x24,0xA4,0x64,0x04,0x00,
0x04,0x04,0xFF,0x00,0x01,0x00,0xFF,0x41,0x21,0x12,0x0C,0x1B,0x61,0xC0,0x40,0x00,//Һ
0x00,0x00,0x00,0x00,0x7E,0x2A,0x2A,0x2A,0x2A,0x2A,0x2A,0x7E,0x00,0x00,0x00,0x00,
0x00,0x7F,0x25,0x25,0x25,0x25,0x7F,0x00,0x00,0x7F,0x25,0x25,0x25,0x25,0x7F,0x00,//
0x10,0xD0,0xFF,0x50,0x90,0x04,0xF4,0x54,0x5F,0x54,0x54,0x5F,0xF4,0x04,0x00,0x00,
0x03,0x00,0xFF,0x00,0x00,0x84,0x85,0x45,0x35,0x0F,0x15,0x25,0x65,0xC4,0x44,0x00,//ģ
0x10,0x10,0xFF,0x10,0x10,0x00,0x08,0x08,0xFF,0x08,0x08,0x08,0xF8,0x00,0x00,0x00,
0x08,0x18,0x0F,0x04,0x85,0x41,0x31,0x0D,0x03,0x05,0x09,0x11,0x31,0x61,0x21,0x00//
};
const int cnt=5;
const int ptr[5]={10,15,20,25,30};
/*1ӳ*/
static void Wait1ms(void) {
  int cnt = 0;
  while (cnt <40) cnt++;
}
/*nӳ*/ 
void WaitNms(int n){
   int i;
   for(i=1;i<=n;i++) Wait1ms();
}	
/*״̬λ-*/
void BFReadL(void){
	unsigned char temp; 
	while(1){
		DDRB=0x00;
		BSET(PTC,2);				//E1=1
		BCLR(PTC,3);				//E2=0
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x80)==0) break;
	}
}
/*״̬λ-*/
void BFReadR(void){
	unsigned char temp; 
	while(1){
		DDRB=0x00;
		BCLR(PTC,2);				//E1=0
		BSET(PTC,3);				//E2=1
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x80)==0) break;
	}
}
/*дָ-*/
void WRCommandL(void){
	BFReadL();
	DDRB=0xff;
	BSET(PTC,2);				//E1=1
	BCLR(PTC,3);				//E2=0
	BCLR(PTC,1);				//R/W=0
	BCLR(PTC,0);				//A0=0
	PTB=command;
	BCLR(PTC,2);				//E1=0
	BSET(PTC,1);				//R/W=1
}
/*дָ-*/
void WRCommandR(void){
	BFReadR();
	DDRB=0xff;
	BSET(PTC,3);				//E2=1
	BCLR(PTC,2);				//E1=0
	BCLR(PTC,1);				//R/W=0
	BCLR(PTC,0);				//A0=0
	PTB=command;
	BCLR(PTC,3);				//E2=0
	BSET(PTC,1);				//R/W=1
}
/*дʾ-*/
void WRDataL(void){
	command=CLMADD;
	WRCommandL();
	BFReadL();
	DDRB=0xff;
	BSET(PTC,2);				//E1=1
	BCLR(PTC,3);				//E2=0
	BCLR(PTC,1);				//R/W=0
	BSET(PTC,0);				//A0=1
	PTB=data;
	BCLR(PTC,2);				//E1=0
	CLMADD++;
	BSET(PTC,1);				//R/W=1
}
/*дʾ-*/
void WRDataR(void){
	command=CLMADD;
	WRCommandR();
	BFReadR();
	DDRB=0xff;
	BSET(PTC,3);				//E2=1
	BCLR(PTC,2);				//E1=0
	BCLR(PTC,1);				//R/W=0
	BSET(PTC,0);				//A0=1
	PTB=data;
	BCLR(PTC,3);				//E2=0
	CLMADD++;
	BSET(PTC,1);				//R/W=1
}
/*ʾ-*/
int RDDataL(void){
	DDRB=0xff;
	BSET(PTC,2);				//E1=1
	BCLR(PTC,3);				//E2=0
	command=CLMADD;
	WRCommandL();
	BFReadL();	
	BCLR(PTC,1);				//R/W=0
	BSET(PTC,0);				//A0=1
	DDRB=0x00;						
	data=PTB;
	BCLR(PTC,3);				//E2=0
	CLMADD++;
	BSET(PTC,1);				//R/W=1
}
/*ʾ-*/
int RDDataR(void){
	DDRB=0xff;
	BSET(PTC,3);				//E2=1
	BCLR(PTC,2);				//E1=0
	command=CLMADD;
	WRCommandR();
	BFReadR();	
	BCLR(PTC,1);				//*R/W=0
	BSET(PTC,0);				//A0=1
	DDRB=0x00;						
	data=PTB;
	BCLR(PTC,3);				//E2=0
	CLMADD++;
	BSET(PTC,1);				//R/W=1
}		
/*ʾ-*/
void DisOnL(void){
	unsigned char temp; 
	while(1){
		command=0xaf;
		WRCommandL();
		BFReadL();
		DDRB=0x00;  //BΪ
		BSET(PTC,2);				//E1=1
		BCLR(PTC,3);				//E2=0
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x20)==0) break;
	}
}
/*ʾ-*/
void DisOffL(void){
	unsigned char temp;
	while(1){ 
		command=0xae;
		WRCommandL();
		BFReadL();
		DDRB=0x00;  //BΪ
		BSET(PTC,2);				//E1=1
		BCLR(PTC,3);				//E2=0
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x20)==0x20) break;
	}
}
/*ʾ-*/
void DisOnR(void){
	unsigned char temp; 
	while(1){
		command=0xaf;
		WRCommandR();
		BFReadR();
		DDRB=0x00;  //BΪ
		BSET(PTC,3);				//E2=1
		BCLR(PTC,2);				//E1=0
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x20)==0) break;
	}
}
/*ʾ-*/
void DisOffR(void){
	unsigned char temp;
	while(1){ 
		command=0xae;
		WRCommandR();
		BFReadR();
		DDRB=0x00;  //BΪ
		BSET(PTC,3);				//E2=1
		BCLR(PTC,2);				//E1=0
		BSET(PTC,1);				//R/W=1
		BCLR(PTC,0);				//A0=0
		temp=PTB;
		if ((temp&0x20)==0x20) break;
	}
}
/*ʾRAM-*/
void CLRDisplayL(void){

	PAGEADD=0xB8;		//ҳַ
	CLMADD=0x00;
	for(PAGENUM=0X04;PAGENUM>0;PAGENUM--){
		command=PAGEADD;
		WRCommandL(); 
   		data=0x00;
   		CLMADD=0x00;
		for(CLMSUM=0X50;CLMSUM>0;CLMSUM--){
			BFReadL();
   			WRDataL();			
		}
		PAGEADD++;			//ҳ1
	}
}
/*ʾRAM-*/
void CLRDisplayR(void){
	PAGEADD=0xB8;		//ҳַ
	CLMADD=0x00;
	for(PAGENUM=0x04;PAGENUM>0;PAGENUM--){
		command=PAGEADD;
		WRCommandR(); 
   		data=0x00;
   		CLMADD=0x00;
		for(CLMSUM=0X50;CLMSUM>0;CLMSUM--){
			BFReadR();
   			WRDataR();			
		}
		PAGEADD++;			//ҳ1
	}
}
/*ʼEPSON SED1520 LCDʾ-*/
void Init_LCDL(void){ 
	DisOffL();
	command=0xa4;				//ֹ˳״̬
   	WRCommandL();
   	command=0xa9;				//ռձΪ132
   	WRCommandL();  
   	command=0xe2;				//λ
   	WRCommandL();
   	command=0xa0;				//ADCѡ
   	WRCommandL(); 
   	CLRDisplayL();
   	BFReadL();
   	DisOnL(); 	      
}
/*ʼEPSON SED1520 LCDʾ-*/
void Init_LCDR(void){ 
	DisOffR();
	command=0xa4;				//ֹ˳״̬
   	WRCommandR();
   	command=0xa9;				//ռձΪ132
   	WRCommandR();  
   	command=0xe2;				//λ	
   	WRCommandR();
   	command=0xa0;				//ADCѡ
   	WRCommandR(); 
   	CLRDisplayR();
   	BFReadR();
   	DisOnR(); 	      
}
/*ʾַ-*/
void DisplayCharL(void){
	command=Row;
	WRCommandL();
	command=PAGEADD;
	WRCommandL();
	for(m=0;m<6;m++)	//68 
	{
		data=CTable[i*8+m];
		WRDataL();
	}
}
/*ʾַ-*/
void DisplayCharR(void){
	command=Row;
	WRCommandR();
	command=PAGEADD;
	WRCommandR();
	for(m=0;m<6;m++)	//68 
	{
		data=CTable[i*8+m];
		WRDataR();
	}
}
/*ʾʾ*/
void DisplayChar(void)
{	
	PAGEADD=0xbb;
	
	for(i=0;i<7;i++)		
		{	
			CLMADD=i*6;		//ʼΪ0
			DisplayCharL();}
	for(i=8;i<16;i++)
		{	
			CLMADD=(i-8)*6;
		 	DisplayCharR();}

}	
/*ʾַ-*/
void DisplayChinaL(void){
	command=Row;
	WRCommandL();
	command=PAGEADD;
	WRCommandL();
	i=i*32;
	for (k=0;k<16;k++){
		data=table[i+k];
		WRDataL();
	}
	CLMADD-=16;
	PAGEADD+=1;
	command=PAGEADD;
	WRCommandL();
	for (;k<32;k++){
		data=table[i+k];
		WRDataL();
	}	
}
/*ʾַ-*/
void DisplayChinaR(void){
	command=Row;
	WRCommandR();
	command=PAGEADD;
	WRCommandR();
	i=i*32;
	for (k=0;k<16;k++){
		data=table[i+k];
		WRDataR();
	}
	CLMADD-=16;
	PAGEADD+=1;
	command=PAGEADD;
	WRCommandR();
	for (k=0;k<32;k++){
		data=table[i+k];
		WRDataR();
	}
}
/*ʾַ*/
void DisplayChinese(void){
	   	   	
   	i=0;					//Һ
   	PAGEADD=0xb8;
   	CLMADD=7;
   	DisplayChinaL();
   	
   	i=1;					//
   	PAGEADD=0xb8;
   	CLMADD=30;
   	DisplayChinaL();
   	
   	i=2;					//ģ
   	PAGEADD=0xb8;
   	CLMADD=3;
   	DisplayChinaR();
   	
   	i=3;					//
   	PAGEADD=0xb8;
   	CLMADD=26;
   	DisplayChinaR();
}
/*Ļ*/
/*Ϲ*/
void UpScroll(void)
{
	while(1){
		Row=0xc0;
		for(i=0;i<=32;i++){			
			DisplayChinese();
			DisplayChar();
			WaitNms(500);
			Row+=1;		
		}
	}	
}
/*¹*/
void DownScroll(void)
{
	while(1){
		Row=0xdf;
		for(i=0;i<=32;i++){			
			DisplayChinese();
			DisplayChar();
			WaitNms(500);
			Row-=1;		
		}
	}	
}
/*ͼηʽ,ӳ򡣸óڵrow(0-31)Сcol(0-99)л㣬СԵΪλ.
ӳöݲͶ޸ģдܡö޸ģд˳޸ģдĹֻд
ʾݲָܲ
*/
void DrawDot(int row,int col) 
{	
	int pageaddr,pagelr,data0,bit;
	int bitset=0x01;
	PAGEADD=0xB8;
		
	pageaddr=row/8;				//ҳַ
	pagelr=PAGEADD|pageaddr;
	command=pagelr;
	WRCommandL();
	WRCommandR();
	
	bit=(bitset<<(row%8));	
	
	if (col<50)
	{	
		command=col;			//еַ
		WRCommandL();
				
		command=0xe0;			//ö޸ģд
		WRCommandL();
		
		data0=RDDataL();		//ն
		data0=RDDataL();		//ȡôĳʼ
				
		data=(data0|bit);
		WRDataL();
		
		command=0xEE;			//˳޸ģд
		WRCommandL();
	}
		else
		{
			col-=50;
			command=col;			//еַ
			WRCommandR();
				
			command=0xe0;			//ö޸ģд
			WRCommandR();
		
			data0=RDDataR();		//ն
			data0=RDDataR();		//ȡôĳʼ
				
			data0|=bit;				
			data=data0;
			WRDataR();
		
			command=0xEE;			//˳޸ģд
			WRCommandR();							
		   }
}
/*ӳ*/
void ClrDot(int row,int col) 
{	
	int pageaddr,pagelr,data0,bit;
	int bitclr=0x01;
	PAGEADD=0xB8;
	
	pageaddr=row/8;				//ҳַ
	pagelr=PAGEADD|pageaddr;
	command=pagelr;
	WRCommandL();
	WRCommandR();	
	
	bit=~(bitclr<<(row%8));	
	
	if (col<50)
	{	
		command=col;			//еַ
		WRCommandL();
				
		command=0xe0;			//ö޸ģд
		WRCommandL();
		
		data0=RDDataL();		//ն
		data0=RDDataL();		//ȡôĳʼ
				
		data=(data0&bit);
		WRDataL();
		
		command=0xEE;			//˳޸ģд
		WRCommandL();
	}
		else
		{
			col-=50;
			command=col;			//еַ
			WRCommandR();
				
			command=0xe0;			//ö޸ģд
			WRCommandR();
		
			data0=RDDataR();		//ն
			data0=RDDataR();		//ȡôĳʼ
				
			data=(data0&bit);
			WRDataR();
		
			command=0xEE;			//˳޸ģд
			WRCommandR();							
		   }
}
/*ӳ:Ϊ˻رܸӵĸ,΢ֵķ*/
/*(x,y)Ϊ,(x1,y1)Ϊյ㻭һֱ*/
void DrawLines(int x,int y,int x1,int y1) 
{
	int dx,dy,err = 0;
	if(y != y1)
	{
		if(y1 < y) /*ж䱣֤y1>=yǰ*/
		{
			dx = y1; dy = x1;
			y1 = y;  x1 = x;
			y = dx;  x = dy;
		}
		dy = y1 - y;
		dx = x1 - x;
		if((x1 >= x)&&((y1 - y) <= (x1 - x)))
		{
			for(;x != x1;)
			{
				if(err < 0)
				{
					DrawDot(x + 1,y);
					x += 1;
					err += dy;
				}
				else
				{
					DrawDot(x + 1,y + 1);
					x += 1;
					y += 1;
					err += (dy - dx);
				}
			}
		}
		else
			if((x1 >= x)&&((y1 - y) > (x1 - x)))
			{
				for(;y != y1;)
				{
					if(err < 0)
					{
						DrawDot(x + 1,y + 1);
						x += 1;
						y += 1;
						err += (dy - dx);
					}
					else
					{
						DrawDot(x,y + 1);
						y += 1;
						err -= dx;
					}
				}
			}
			else
				if((x1 < x)&&((y1 - y) <= (x - x1)))
				{
					for(;x != x1;)
					{
						if(err < 0)
						{
							DrawDot(x - 1,y);
							x -= 1;
							err += dy;
						}
						else
						{
							DrawDot(x - 1,y + 1);
							x -= 1;
							y += 1;
							err += (dy + dx);
						}
					}
				}
				else
					if((x1 < x)&&((y1 - y) > (x1 - x)))
					{
						for(;y != y1;)
						{
							if(err < 0)
							{
								DrawDot(x - 1,y + 1);
								x -= 1;
								y += 1;
								err += (dy + dx);
							}
							else
							{
								DrawDot(x,y + 1);
								y += 1;
								err += dx;
							}
						}
					}
	}	
	else
	{
		dx = x; dy = x1;
		if(x < x1)
		{
			dx = x1;
			dy = x;
		}
		for(;dy < dx;dy++)
			DrawDot(dy,y);
	}
}
/*Բӳ:ӦñɭķԲ㷨һԲ,(x,y)ΪԲrΪ뾶һԲ*/
void DrawCircle(int x,int y,int r)
{
	int x1,y1,x2,y2,a,b,delta1,delta2;
	x1 = 0; y1 = r;
	x2 = r; y2 = 0;
	for(;x1 <= x2;)
	{	a = x1; b = y1;
		delta1 = (a + 1) * (a + 1) + b * b - r * r - b;
		if(delta1 >= 0)
		{	x1 += 1;
			y1 -= 1;
		}
		else
			{x1 += 1;
			}
		a = y2; b = x2;
		delta2 = (a + 1) * (a + 1) + b * b - r * r - b;
		if(delta2 >= 0)
		{	x2 -= 1;
		 	y2 += 1;
		}
		else
			{y2 += 1;
			}
		DrawDot(x1 + x,y1 + y);
		DrawDot(x1 + x,-1 * y1 + y);
		DrawDot(-1 * x1 + x,y1 + y);
		DrawDot(-1 * x1 + x,-1 * y1 + y);
		DrawDot(x2 + x,y2 + y);
		DrawDot(x2 + x,-1 * y2 + y);
		DrawDot(-1 * x2 + x,y2 + y);
		DrawDot(-1 * x2 + x,-1 * y2 + y);
	}
}
/*,x0()y0()Ϊԭ꣬lengthΪ곤*/
void DrawCoordinate(int x0,int y0,int length)
{
	DrawLines(x0,y0-4,x0,y0+length);	//
	DrawLines(x0+4,y0,x0-length,y0);	//	
	DrawLines(x0,y0+length,x0-4,y0+length-4);	//ͷ
	DrawLines(x0,y0+length,x0+4,y0+length-4);	
	DrawLines(x0-length,y0,x0-length+4,y0+4);	//ͷ
	DrawLines(x0-length,y0,x0-length+4,y0-4);	
}
//еֵ
int GetMaxNum(int *ptr,int cnt)
{
	int i,max = 0;
	for(i = 0;i < cnt;i++)
	{
		if(max < ptr[i])
			max = ptr[i];
	}
	return max;
}
char CanDraw(int x,int y,char fillstyle)
{
	if(fillstyle == 0)
	{
		if((x + y) / 4 * 4 == x + y)
			return 1;	/*żĻ1,õ*/
		else
			return 0;
	}
	else
	{
		if(((x - y) >= 0 ? (x - y) : (y - x)) / 4 * 4 == ((x - y) >= 0 ? (x - y) : (y - x)))
			return 1;	/*żĻ1,õ*/
		else
			return 0;
	}
}
/*ĻĳһͿ:x,yϽ,(x1,y1)½,һ䷽ʽ*/
void BarFill(int x,int y,int x1,int y1,char fillstyle)
{
	int i,j;
	for(i = y;i <= y1;i++)
		for(j = x;j <= x1;j++)
			if((CanDraw(j,i,fillstyle))||((i == y)||(i == y1)||(j == x1)||(j == x)))
				DrawDot(i,j);
}
/*ͼʾ:һ(cntԪ)ʾһ״ʾͼ,
x,y,x1,y1һϽǺ½ǵ*/
void DrawBars(int *ptr,int cnt,int x,int y,int x1,int y1)
{	
	int k;
	int yitem = ((y1-y+1)/GetMaxNum(ptr,cnt));
	int xitem = ((x1-x+1)/cnt);
	DrawCoordinate(y1,x,x1-x+5);
	if(yitem == 0)
		yitem = 1;
	for(k = 0;k < cnt;k++)
	{
		if(k / 2 * 2 == k) /*kΪżĻ*/
		{
			BarFill(x+4+xitem*k,y1-yitem*ptr[k],x+xitem*(k+1),y1,0);
		}
		else
			BarFill(x+4+xitem*k,y1-yitem*ptr[k],x+xitem*(k+1),y1,1);
	}
	
}			
/*״̬*/
/*״̬*/
void StatisDriveON(void){
	command=0xAe;					//ʾ
	WRCommandL();
	WRCommandR();
	
	command=0xA5;					//״̬
	WRCommandL();
	WRCommandR();
} 
/*˳״̬*/
void StatisDriveOFF(void){
	command=0xAF;					//˳״̬
	WRCommandL();
	WRCommandR();
	
	command=0xA4;					//ʾ
	WRCommandL();
	WRCommandR();	
}
/*ADCʵ*/

/**/
void ADCReverse(void){
	command=0xA1;					//
	WRCommandL();
//	WRCommandR();
	
	command=0xB8;					//ҳַ
	WRCommandL();
//	WRCommandR();
	
	command=0x00;					//еַ
	WRCommandL();
//	WRCommandR();
	
	data=0x0F;
	for(i=0;i<50;i++){
		WRDataL();
//		WRDataR();
		WaitNms(1000);}
}
/*вõ4*4̡
  0xEE,"F1",0xDE,"1",0xBE,"2",0x7E,"3",
  0xED,"F2",0xDD,"4",0xBD,"5",0x7D,"6",
  0xEB,"F3",0xDB,"7",0xBB,"8",0x7B,"9",
  0xE7,"F4",0xD7,"clear",0xB7,"0",0x77,"enter"
  KeyValue[4]={0xfe,0xfd,0xfb,0xf7};
  KeyTable[16]={0xee,0xde,0xbe,0x7e,
  		0xed,0xdd,0xbd,0x7d,
  		0xeb,0xdb,0xbb,0x7b,
  		0xe7,0xd7,0xb7,0x77};

GP32PTAڼмжϹܣ˽̵Сй8ӵPTAϣ
14ӵPTA03ϣ14ӵPTA47ϡṩһ̱ʵ
漰ɨ̻üֵжϻȡֵ̱⡣ڱʱPTA03Ϊ
PTA47Ϊ벢ڲ裬ô"F1"ӦPTA7PTA011101110$EE;
"1"ӦPTA7PTA011011110$DE;...;"#"ӦPTA7PTA001110111$77*/
/*̳ʼ*/
void KeyInit(void){
	PTA=0x00;
	DDRA=0x0f;
	PTAPUE=0xf0;
	INTKBIER=0xf0;
}
/*ֵ*/
unsigned char ReadKey(void){
	unsigned char temp,tempdata,key;
	unsigned int k;
	for(k=0;k<4;k++){			//ɨ
		temp=KeyValue[k];		//ʹkɨΪ͵ƽ
		tempdata=PTA;			//
		tempdata|=0x0F;			//PTA4-7ԭ̬,PTA0-3Ϊ1
		tempdata&=temp;
		PTA=tempdata;
		nop();
		nop();
		
		tempdata=PTA;
		tempdata&=0xF0;
		if (tempdata!=0xf0) {
			key=PTA;
			goto readkey1;
		}
	}
readkey1: return key;
}		
/*ж*/
@interrupt void KeyISR(void){
	unsigned char KeyValue;
	unsigned int OutValue;
	unsigned char k;
		
	INTKBSCR|=0x02;
	KeyValue=ReadKey();
	for(k=0;k<16;k++){
		if(KeyValue==KeyTable[k]){
			OutValue=k;			
		}
//		break;
	}
/*F1ʾģF2ıʽʾ֣F3ͼηʽʾ֣F4*/
	switch(OutValue){
	case 0:						//"F1"ʾַ
		CLRDisplayL();
		CLRDisplayR();
		DisplayChar();
		break;
	case 1:						//"1"
		CLRDisplayL();
		CLRDisplayR();
		DrawDot(15,15);			//
		DrawDot(50,90);
		break;
	case 2:						//"2"
		CLRDisplayL();
		CLRDisplayR();
		DrawDot(10,10);			//Ȼ
		DrawDot(40,90);
		WaitNms(2000);
		ClrDot(10,10);
		ClrDot(40,90);		
		break;
	case 3: 					//"3"
		CLRDisplayL();
		CLRDisplayR();
		DrawLines(20,10,30,90);//		
		break;
	case 4:						//"F2"
		CLRDisplayL();
		CLRDisplayR();
		
		break;
	case 5:						//"4"
		CLRDisplayL();
		CLRDisplayR();
		DrawCircle(40,40,30);	//Բ	 	
		break; 
	case 6:						//"5"
		CLRDisplayL();
		CLRDisplayR();
		DrawCoordinate(50,6,40);	//
		break;
	case 7:						//"6"	
		CLRDisplayL();
		CLRDisplayR();
		DrawBars(ptr,5,5,5,58,58);	//״ͼ
		break;
	case 8:						//"F3"ͼηʽʾ
		CLRDisplayL();
		CLRDisplayR();
		DisplayChinese();
		break;
	case 9:						//"7"
		CLRDisplayL();
		CLRDisplayR();
//		LeftScroll();			//				
		break;
	case 10:					//"8"							
		CLRDisplayL();
		CLRDisplayR();
		UpScroll();				//Ϲ
		break;				
	case 11:					//"9"
		CLRDisplayL();
		CLRDisplayR();
//		RightScroll();			//ҹ
		break;
	case 12:					//"F4"
		CLRDisplayL();
		CLRDisplayR();			//
		ADCReverse();
		break;
	case 13:					//"Clear"
		CLRDisplayL();
		CLRDisplayR();
		break;
	case 14:					//"0"
		CLRDisplayL();
		CLRDisplayR();
		DownScroll();			//¹		
		break;
	case 15:					//"Enter"
		
		break;
	} 	
	KeyInit();
	INTKBSCR|=0x04;	
	INTKBSCR&=~0x02;	
}	 
//PLLʼ
void PLLInit(void){
	PCTL=0;				//رPLL׼
    	PBWC=0x80;			//Զģʽ
   	PCTL=1;				//R=1
    	PMSH=1;    			
   	PMSL=0x2c;			//N=012c
    	PMRS=0x80;			//L=80
    	PCTL=0x22;			//E=2,PLLON=1,PLL
    	while(!(PBWC&0x40));		//ȴȶ
   	PCTL|=0x10;			//ƵѡPLLΪʱԴ
}
/* ϵͳģ飨SIMʼֹCOPŹ*/
void SIMInit(void) {
	CONFIG2=0x01; /* ڲʱSCIʱ*/
	CONFIG1=0x3d; /* LVEλźţֹLVIĵԴLVI5V,*/
                  /* 32CGMXCLK˳STOPģʽֹCOPģ */ 
}
/**/
void main(void)
{ 
	unsigned char Row=0xc0;
	sei();      		//ж
	SIMInit();  		//SIMʼ
	PLLInit();  		//PLLʼ		
	DDRC=0x0F;
	PTCPUE=0xFF;		//
   	PTC.byte=0xff;
   	DDRC=0xFF;
   	PTB=0xff;
   	DDRB=0xff;

   	Init_LCDL();		//Ļҳʼ
   	Init_LCDR();   		//Ļҳʼ
   	
        DisplayChinese();	//ʼʾ
 	DisplayChar();		//ʼʾ

//	UpScroll();	
//	DownScroll();
//	ADCReverse();
//  DrawDot(0,0);
//  DrawDot(5,60);
//  ClrDot(5,10); 
 	KeyInit();		//̳ʼ
 	cli(); 	   		//ж
   	for(;;);		//ȴжϣд
}
